program dd2_levels_to_bmp;

type

Arr=array [1..1] of word;
PArr=^arr;
Matrix=array [1..1] of PArr;
PMatrix=^Matrix;

var

f_level,f_tiles,f_level_bmp: file of word;
header: array [1..59] of word;
f_level_name,f_level_bmp_name,numlev: string;
tiles,tile_num:PMatrix;
level_width,level_height,tiles_width,tiles_height,x:word;
a,b:longint;
r:real;
i,j,k,n,l:integer;

 procedure getmemory (var matrix:Pmatrix; width,height:word);
  var i:integer;
   begin
    getmem (matrix, width*sizeof(Parr));
     for i:=1 to width do
      getmem (matrix^[i], height*sizeof(word));
   end;

 procedure freememory (matrix:Pmatrix; width,height:word);
  var i:integer;
   begin
    if matrix<>nil then
     begin
      for i:=1 to width do
       freemem (matrix^[i], height*sizeof(word));
       freemem (matrix, width*sizeof(Parr));
    end;
   end;

 begin
  assign(f_tiles, 'tiles.bmp');
  reset(f_tiles);
   for i:=1 to 59 do
    read(f_tiles,header[i]);
  tiles_width:=52;
  tiles_height:=1056;
  getmemory(tiles,tiles_width,tiles_height);
   for j:=1 to tiles_height do
   for i:=1 to tiles_width do
    read(f_tiles,tiles^[i]^[j]);
  close(f_tiles);

  for k:=1 to 8 do
   begin
    str(k,numlev);
    f_level_name:='LEVEL0'+numlev+'.DD2';
    assign(f_level, f_level_name);
    {$I-} reset(f_level);{$I+}
    if ioresult<>0 then continue;
    f_level_bmp_name:='LEVEL0'+numlev+'.bmp';
    assign (f_level_bmp, f_level_bmp_name);
    rewrite(f_level_bmp);

    seek(f_level,2);
    read(f_level,level_width);
    read(f_level,level_height);

    level_width:=level_width-4;
    level_height:=level_height-4;

    getmemory(tile_num,level_width,level_height);
    seek(f_level,18+(level_width+4)*2);
     for j:=1 to level_height do
      begin
       read(f_level,x,x);
        for i:=1 to level_width do
         begin
          read(f_level,tile_num^[i]^[j]);
         end;
       read(f_level,x,x);
      end;
    close(f_level);

    header[10]:=level_width*16;
    header[11]:=0;
    header[12]:=level_height*16;
    header[13]:=0;

    r:=header[10]*header[12]/2;
    x:=trunc(r);

    header[2]:=(x+118) mod 65536;
    header[3]:=(x+118) div 65536;
    header[18]:=x mod 65536;
    header[19]:=x div 65536;

    for i:=1 to 59 do
     write(f_level_bmp,header[i]);

    for j:=level_height downto 1 do
     begin
      for i:=1 to level_width do
       begin
        a:=tile_num^[i]^[j] div 13;
        b:=tile_num^[i]^[j] mod 13;

        r:=(219648-(208-(b*16)+3328*a+3120))/4;
        x:=trunc(r);

        a:=x div tiles_width;
        b:=x mod tiles_width;

        seek(f_level_bmp,59+(i-1)*4+(level_height-j)*(64*level_width));
         for l:=1 to 16 do
          begin
           for n:=1 to 4 do
            begin
             write(f_level_bmp,tiles^[b+n]^[a+l]);
            end;
          seek(f_level_bmp,59+(i-1)*4+(level_height-j)*(64*level_width)+level_width*4*l);
          end;
       end;
     end;
    close(f_level_bmp);
    freememory(tile_num,level_width,level_height);
   end;
  freememory(tiles,tiles_width,tiles_height);
 end.